blob: ef173026c18a5ebcb007771b65762f7b77343090 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010044export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010059 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070060fi
61
Orion Hodson64fe3be2018-06-15 12:50:22 +010062export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070063
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Andreas Gampef47fb2f2016-06-24 22:30:29 -070079# ANDROID_HOST_OUT is not set in a build environment.
80if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080081 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070082fi
83
Igor Murashkine5181932017-06-15 16:03:50 -070084# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070085if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070086 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
87fi
88
Igor Murashkin271a0f82017-02-14 21:14:17 +000089# Zipalign is not on the PATH in some configs, auto-detect it.
90if [ -z "$ZIPALIGN" ]; then
91 if which zipalign >/dev/null; then
92 ZIPALIGN="zipalign";
93 else
94 # TODO: Add a dependency for zipalign in Android.run-test.mk
95 # once it doesn't depend on libandroidfw (b/35246701)
96 case "$OSTYPE" in
97 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
98 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
99 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
100 esac
101 fi
102fi
103export ZIPALIGN
104
David Brazdil122c6632018-01-24 17:32:49 +0000105# If hiddenapi was not set by the environment variable, assume it is in
106# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000107if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000108 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000109fi
110
Roland Levillain76cfe612017-10-30 13:14:28 +0000111chroot=
112
jeffhao5d1ac922011-09-29 17:41:15 -0700113info="info.txt"
114build="build"
115run="run"
116expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700117check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700118output="output.txt"
119build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100120cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700121strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700122lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700123testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700124run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000125build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700126
Alex Light91de25f2015-10-28 17:00:06 -0700127quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000128debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700129prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700130target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700131dev_mode="no"
132update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700133debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000134relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800135runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700136usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700137build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700138suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700139trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700140trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700141basic_verify="false"
142gc_verify="false"
143gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700144jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700145jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700146jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700147jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700148strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700149always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700150never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700151have_patchoat="yes"
152have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800153multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000154android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700155bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800156suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700157# By default we will use optimizing.
158image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000159image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700160
161while true; do
162 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700163 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700164 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100165 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700166 shift
Alex Light91de25f2015-10-28 17:00:06 -0700167 elif [ "x$1" = "x--quiet" ]; then
168 quiet="yes"
169 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700170 elif [ "x$1" = "x--use-java-home" ]; then
171 if [ -n "${JAVA_HOME}" ]; then
172 export JAVA="${JAVA_HOME}/bin/java"
173 export JAVAC="${JAVA_HOME}/bin/javac -g"
174 else
175 echo "Passed --use-java-home without JAVA_HOME variable set!"
176 usage="yes"
177 fi
178 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800179 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700180 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800181 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800182 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700183 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700184 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700185 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100186 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700187 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800188 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700189 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700190 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700191 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700192 shift
193 elif [ "x$1" = "x--dalvik" ]; then
194 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800195 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700196 shift
Alex Light03a112d2014-08-25 13:25:56 -0700197 elif [ "x$1" = "x--no-patchoat" ]; then
198 have_patchoat="no"
199 shift
200 elif [ "x$1" = "x--no-image" ]; then
201 have_image="no"
202 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800203 elif [ "x$1" = "x--multi-image" ]; then
204 multi_image_suffix="-multi"
205 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700206 elif [ "x$1" = "x--pic-test" ]; then
207 run_args="${run_args} --pic-test"
208 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700209 elif [ "x$1" = "x--relocate" ]; then
210 relocate="yes"
211 shift
212 elif [ "x$1" = "x--no-relocate" ]; then
213 relocate="no"
214 shift
215 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100216 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700217 prebuild_mode="yes"
218 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800219 elif [ "x$1" = "x--compact-dex-level" ]; then
220 option="$1"
221 shift
222 run_args="${run_args} $option $1"
223 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700224 elif [ "x$1" = "x--strip-dex" ]; then
225 run_args="${run_args} --strip-dex"
226 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000227 elif [ "x$1" = "x--debuggable" ]; then
228 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000229 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000230 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700231 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100232 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700233 prebuild_mode="no"
234 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700235 elif [ "x$1" = "x--gcverify" ]; then
236 basic_verify="true"
237 gc_verify="true"
238 shift
239 elif [ "x$1" = "x--gcstress" ]; then
240 basic_verify="true"
241 gc_stress="true"
242 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700243 elif [ "x$1" = "x--jvmti-step-stress" ]; then
244 jvmti_step_stress="true"
245 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700246 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
247 jvmti_redefine_stress="true"
248 shift
Alex Light43e935d2017-06-19 15:40:40 -0700249 elif [ "x$1" = "x--jvmti-field-stress" ]; then
250 jvmti_field_stress="true"
251 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700252 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
253 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700254 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800255 elif [ "x$1" = "x--suspend-timeout" ]; then
256 shift
257 suspend_timeout="$1"
258 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700259 elif [ "x$1" = "x--image" ]; then
260 shift
261 image="$1"
262 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700263 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000264 elif [ "x$1" = "x-Xcompiler-option" ]; then
265 shift
266 option="$1"
267 run_args="${run_args} -Xcompiler-option $option"
268 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000269 elif [ "x$1" = "x--build-option" ]; then
270 shift
271 option="$1"
272 build_args="${build_args} $option"
273 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700274 elif [ "x$1" = "x--runtime-option" ]; then
275 shift
276 option="$1"
277 run_args="${run_args} --runtime-option $option"
278 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700279 elif [ "x$1" = "x--gdb-arg" ]; then
280 shift
281 gdb_arg="$1"
282 run_args="${run_args} --gdb-arg $gdb_arg"
283 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700284 elif [ "x$1" = "x--debug" ]; then
285 run_args="${run_args} --debug"
286 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700287 elif [ "x$1" = "x--debug-wrap-agent" ]; then
288 run_args="${run_args} --debug-wrap-agent"
289 shift
Alex Light0e151e72017-10-25 10:50:35 -0700290 elif [ "x$1" = "x--with-agent" ]; then
291 shift
292 option="$1"
293 run_args="${run_args} --with-agent $1"
294 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700295 elif [ "x$1" = "x--debug-agent" ]; then
296 shift
297 option="$1"
298 run_args="${run_args} --debug-agent $1"
299 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700300 elif [ "x$1" = "x--gdb" ]; then
301 run_args="${run_args} --gdb"
302 dev_mode="yes"
303 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700304 elif [ "x$1" = "x--strace" ]; then
305 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700306 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700307 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700308 elif [ "x$1" = "x--zygote" ]; then
309 run_args="${run_args} --zygote"
310 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800311 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000312 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700313 image_suffix="-interpreter"
314 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800315 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700316 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000317 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800318 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700319 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700320 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800321 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700322 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700323 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700324 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700325 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700326 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700327 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700328 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700329 elif [ "x$1" = "x--no-optimize" ]; then
330 run_args="${run_args} --no-optimize"
331 shift
332 elif [ "x$1" = "x--no-precise" ]; then
333 run_args="${run_args} --no-precise"
334 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700335 elif [ "x$1" = "x--invoke-with" ]; then
336 shift
337 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700338 if [ "x$what" = "x" ]; then
339 echo "$0 missing argument to --invoke-with" 1>&2
340 usage="yes"
341 break
342 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700343 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700344 shift
345 elif [ "x$1" = "x--dev" ]; then
346 run_args="${run_args} --dev"
347 dev_mode="yes"
348 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700349 elif [ "x$1" = "x--build-only" ]; then
350 build_only="yes"
351 shift
352 elif [ "x$1" = "x--output-path" ]; then
353 shift
354 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700355 if [ "x$tmp_dir" = "x" ]; then
356 echo "$0 missing argument to --output-path" 1>&2
357 usage="yes"
358 break
359 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700360 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000361 elif [ "x$1" = "x--chroot" ]; then
362 shift
363 if [ "x$1" = "x" ]; then
364 echo "$0 missing argument to --chroot" 1>&2
365 usage="yes"
366 break
367 fi
368 chroot="$1"
369 run_args="${run_args} --chroot $1"
370 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000371 elif [ "x$1" = "x--android-root" ]; then
372 shift
373 if [ "x$1" = "x" ]; then
374 echo "$0 missing argument to --android-root" 1>&2
375 usage="yes"
376 break
377 fi
378 android_root="$1"
379 run_args="${run_args} --android-root $1"
380 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700381 elif [ "x$1" = "x--update" ]; then
382 update_mode="yes"
383 shift
384 elif [ "x$1" = "x--help" ]; then
385 usage="yes"
386 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700387 elif [ "x$1" = "x--64" ]; then
388 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700389 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700390 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200391 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700392 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200393 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700394 elif [ "x$1" = "x--stream" ]; then
395 trace_stream="true"
396 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700397 elif [ "x$1" = "x--always-clean" ]; then
398 always_clean="yes"
399 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700400 elif [ "x$1" = "x--never-clean" ]; then
401 never_clean="yes"
402 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800403 elif [ "x$1" = "x--dex2oat-swap" ]; then
404 run_args="${run_args} --dex2oat-swap"
405 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700406 elif [ "x$1" = "x--instruction-set-features" ]; then
407 shift
408 run_args="${run_args} --instruction-set-features $1"
409 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700410 elif [ "x$1" = "x--bisection-search" ]; then
411 bisection_search="yes"
412 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000413 elif [ "x$1" = "x--vdex" ]; then
414 run_args="${run_args} --vdex"
415 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000416 elif [ "x$1" = "x--dm" ]; then
417 run_args="${run_args} --dm"
418 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000419 elif [ "x$1" = "x--vdex-filter" ]; then
420 shift
421 filter=$1
422 run_args="${run_args} --vdex-filter $filter"
423 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700424 elif [ "x$1" = "x--random-profile" ]; then
425 run_args="${run_args} --random-profile"
426 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700427 elif [ "x$1" = "x--dex2oat-jobs" ]; then
428 shift
429 run_args="${run_args} -Xcompiler-option -j$1"
430 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700431 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700432 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700433 usage="yes"
434 break
435 else
436 break
437 fi
438done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700439
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100440if [ "$usage" = "no" -a "x$1" = "x" ]; then
441 echo "missing test to run" 1>&2
442 usage="yes"
443fi
444
Roland Levillain76cfe612017-10-30 13:14:28 +0000445# The DEX_LOCATION with the chroot prefix, if any.
446chroot_dex_location="$chroot$DEX_LOCATION"
447
Alex Light10bc5a42016-05-10 10:01:22 -0700448run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700449# Allocate file descriptor real_stderr and redirect it to the shell's error
450# output (fd 2).
451if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
452 exec {real_stderr}>&2
453else
454 # In bash before version 4.1 we need to do a manual search for free file
455 # descriptors.
456 FD=3
457 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
458 real_stderr=$FD
459 eval "exec ${real_stderr}>&2"
460fi
461if [ "$quiet" = "yes" ]; then
462 # Force the default standard output and error to go to /dev/null so we will
463 # not print them.
464 exec 1>/dev/null
465 exec 2>/dev/null
466fi
467
468function err_echo() {
469 echo "$@" 1>&${real_stderr}
470}
471
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700472# tmp_dir may be relative, resolve.
473#
474# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000475# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700476# Cannot use readlink -m, as it does not exist on Mac.
477# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700478noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700479tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700480mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700481
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800482# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000483if [ ! "$runtime" = "jvm" ]; then
484 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
485fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800486
Alex Lighte7873ec2014-08-12 09:53:50 -0700487if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800488 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
489 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700490fi
491if [ "$gc_verify" = "true" ]; then
492 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
493fi
494if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700495 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700496fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700497if [ "$jvmti_redefine_stress" = "true" ]; then
498 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
499fi
Alex Lightc38c3692017-06-27 15:45:14 -0700500if [ "$jvmti_step_stress" = "true" ]; then
501 run_args="${run_args} --no-app-image --jvmti-step-stress"
502fi
Alex Light43e935d2017-06-19 15:40:40 -0700503if [ "$jvmti_field_stress" = "true" ]; then
504 run_args="${run_args} --no-app-image --jvmti-field-stress"
505fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700506if [ "$jvmti_trace_stress" = "true" ]; then
507 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700508fi
Jeff Hao85139a32014-07-23 11:52:52 -0700509if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700510 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
511 if [ "$trace_stream" = "true" ]; then
512 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
513 # the ability to analyze the file and just write to /dev/null.
514 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
515 # Enable streaming mode.
516 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
517 else
518 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
519 fi
520elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700521 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700522 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700523fi
524
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700525# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000526# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100527function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700528 # Check whether this is a device with native bridge. Currently this is hardcoded
529 # to x86 + arm.
530 x86_arm=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | sort | grep -E '^(arm|x86)$'`
531 # Collapse line-breaks into spaces
532 x86_arm=$(echo $x86_arm)
533 if [ "x$x86_arm" = "xarm x86" ] ; then
534 err_echo "Native-bridge configuration detected."
535 # We only support the main arch for tests.
536 if [ "x${suffix64}" = "x64" ]; then
537 target_arch_name=""
538 else
539 target_arch_name=x86
540 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700541 else
Andreas Gamped0566d42018-06-06 09:54:34 -0700542 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
543 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
544 if [ "x${suffix64}" = "x64" ]; then
545 target_arch_name=${grep64bit}
546 else
547 target_arch_name=${grep32bit}
548 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700549 fi
550}
551
David Brazdil853a4c32015-09-28 16:15:50 +0100552function guess_host_arch_name() {
553 if [ "x${suffix64}" = "x64" ]; then
554 host_arch_name="x86_64"
555 else
556 host_arch_name="x86"
557 fi
558}
559
Alex Lighta59dd802014-07-02 16:28:08 -0700560if [ "$target_mode" = "no" ]; then
561 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700562 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700563 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000564 exit 1
565 fi
566 else
567 # ART/Dalvik host mode.
568 if [ -n "$chroot" ]; then
569 err_echo "--chroot with --host is unsupported"
570 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700571 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700572 fi
573fi
574
Alex Light03a112d2014-08-25 13:25:56 -0700575if [ "$have_patchoat" = "no" ]; then
576 run_args="${run_args} --no-patchoat"
577fi
578
Jeff Hao201803f2013-11-20 18:11:39 -0800579if [ ! "$runtime" = "jvm" ]; then
580 run_args="${run_args} --lib $lib"
581fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700582
Jeff Hao201803f2013-11-20 18:11:39 -0800583if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700584 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000585 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800586 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700587 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700588 else
589 true # defaults to using target BOOTCLASSPATH
590 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800591elif [ "$runtime" = "art" ]; then
592 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100593 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000594 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700595 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800596 else
David Brazdil853a4c32015-09-28 16:15:50 +0100597 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800598 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000599 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800600 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700601 if [ "$relocate" = "yes" ]; then
602 run_args="${run_args} --relocate"
603 else
604 run_args="${run_args} --no-relocate"
605 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700606elif [ "$runtime" = "jvm" ]; then
607 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800608 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700609fi
610
Alex Light03a112d2014-08-25 13:25:56 -0700611if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700612 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700613 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700614 exit 1
615 fi
Alex Light03a112d2014-08-25 13:25:56 -0700616 run_args="${run_args} --no-image"
617fi
618
jeffhao5d1ac922011-09-29 17:41:15 -0700619if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700620 err_echo "--dev and --update are mutually exclusive"
621 usage="yes"
622fi
623
624if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
625 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700626 usage="yes"
627fi
628
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700629if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
630 err_echo "--bisection-search and --prebuild are mutually exclusive"
631 usage="yes"
632fi
633
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700634if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
635 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
636 usage="yes"
637fi
638
Roland Levillain76cfe612017-10-30 13:14:28 +0000639# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
640if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
641 err_echo "--chroot with --bisection-search is unsupported"
642 exit 1
643fi
644
jeffhao5d1ac922011-09-29 17:41:15 -0700645if [ "$usage" = "no" ]; then
646 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
647 test_dir=`basename "$oldwd"`
648 else
649 test_dir="$1"
650 fi
651
652 if [ '!' -d "$test_dir" ]; then
653 td2=`echo ${test_dir}-*`
654 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700655 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700656 usage="yes"
657 fi
658 test_dir="$td2"
659 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700660 # Shift to get rid of the test name argument. The rest of the arguments
661 # will get passed to the test run.
662 shift
663fi
664
665if [ "$usage" = "yes" ]; then
666 prog=`basename $prog`
667 (
668 echo "usage:"
669 echo " $prog --help Print this message."
670 echo " $prog [options] [test-name] Run test normally."
671 echo " $prog --dev [options] [test-name] Development mode" \
672 "(dumps to stdout)."
673 echo " $prog --update [options] [test-name] Update mode" \
674 "(replaces expected.txt)."
675 echo ' Omitting the test name or specifying "-" will use the' \
676 "current directory."
677 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000678 echo " -O Run non-debug rather than debug build (off by default)."
679 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000680 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000681 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800682 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700683 echo " --debug Wait for the default debugger to attach."
684 echo " --debug-agent <agent-path>"
685 echo " Wait for the given debugger agent to attach. Currently"
686 echo " only supported on host."
687 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
688 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700689 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000690 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000691 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700692 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000693 echo " --build-only Build test files only (off by default)."
694 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800695 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000696 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000697 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700698 echo " --verify-soft-fail Force soft fail verification (off by default)."
699 echo " Verification is enabled if neither --no-verify"
700 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000701 echo " --no-optimize Turn off optimization (on by default)."
702 echo " --no-precise Turn off precise GC (on by default)."
703 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700704 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000705 echo " other runtime options are ignored."
706 echo " --no-dex2oat Run as though dex2oat was failing."
707 echo " --no-patchoat Run as though patchoat was failing."
708 echo " --prebuild Run dex2oat on the files before starting test. (default)"
709 echo " --no-prebuild Do not run dex2oat on the files before starting"
710 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700711 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000712 echo " --relocate Force the use of relocating in the test, making"
713 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000714 echo " address before running."
715 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700716 echo " --image Run the test using a precompiled boot image. (default)"
717 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000718 echo " --host Use the host-mode virtual machine."
719 echo " --invoke-with Pass --invoke-with option to runtime."
720 echo " --dalvik Use Dalvik (off by default)."
721 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700722 echo " --use-java-home Use the JAVA_HOME environment variable"
723 echo " to find the java compiler and runtime"
724 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000725 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700726 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000727 echo " --64 Run the test in 64-bit mode"
728 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700729 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700730 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000731 echo " --gcstress Run with gc stress testing"
732 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700733 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700734 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700735 echo " --jvmti-redefine-stress"
736 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000737 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700738 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000739 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000740 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000741 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700742 echo " --instruction-set-features [string]"
743 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800744 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
745 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700746 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700747 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700748 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000749 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800750 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700751 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700752 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700753 exit 1
754fi
755
756cd "$test_dir"
757test_dir=`pwd`
758
759td_info="${test_dir}/${info}"
760td_expected="${test_dir}/${expected}"
761
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700762if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700763 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700764 exit 1
765fi
766
767if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700768 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700769 exit 1
770fi
771
772# copy the test to a temp dir and run it
773
Elliott Hughes510c8782011-10-06 10:57:34 -0700774echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700775
776rm -rf "$tmp_dir"
777cp -Rp "$test_dir" "$tmp_dir"
778cd "$tmp_dir"
779
780if [ '!' -r "$build" ]; then
781 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800782else
783 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700784fi
785
786if [ '!' -r "$run" ]; then
787 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800788else
789 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700790fi
791
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700792if [ '!' -r "$check_cmd" ]; then
793 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800794else
795 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700796fi
797
jeffhao5d1ac922011-09-29 17:41:15 -0700798chmod 755 "$build"
799chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700800chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700801
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700802export TEST_NAME=`basename ${test_dir}`
803
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000804# Tests named '<number>-checker-*' will also have their CFGs verified with
805# Checker when compiled with Optimizing on host.
806if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
807 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
808 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
809 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
810 run_checker="yes"
811
812 if [ "$target_mode" = "no" ]; then
813 cfg_output_dir="$tmp_dir"
814 checker_args="--arch=${host_arch_name^^}"
815 else
816 cfg_output_dir="$DEX_LOCATION"
817 checker_args="--arch=${target_arch_name^^}"
818 fi
819
820 if [ "$debuggable" = "yes" ]; then
821 checker_args="$checker_args --debuggable"
822 fi
823
824 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
825 -Xcompiler-option -j1"
826 fi
827 fi
828fi
829
Mathieu Chartier031768a2015-08-27 10:25:02 -0700830 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700831
Richard Uhler020c0f32017-03-14 16:23:17 +0000832# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
833# ART output to approximately 128MB. This should be more than sufficient
834# for any test while still catching cases of runaway output.
835# Set a hard limit to encourage ART developers to increase the ulimit here if
836# needed to support a test case rather than resetting the limit in the run
837# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000838if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000839 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700840fi
841
Igor Murashkin2de6e082018-02-28 15:25:23 -0800842# Tell the build script which mode (target, host, jvm) we are building for
843# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000844if [[ "$target_mode" == "yes" ]]; then
845 build_args="$build_args --target"
846else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800847 if [[ $runtime == "jvm" ]]; then
848 build_args="$build_args --jvm"
849 else
850 build_args="$build_args --host"
851 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000852fi
853
854if [[ "$dev_mode" == "yes" ]]; then
855 build_args="$build_args --dev"
856fi
857
jeffhao5d1ac922011-09-29 17:41:15 -0700858good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000859good_build="yes"
860good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700861export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700862if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000863 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700864 build_exit="$?"
865 echo "build exit status: $build_exit" 1>&2
866 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800867 echo "${test_dir}: running..." 1>&2
868 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700869 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000870
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800871 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000872 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100873 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000874 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100875 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100876 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000877 checker_exit="$?"
878 if [ "$checker_exit" = "0" ]; then
879 good="yes"
880 fi
Alex Light91de25f2015-10-28 17:00:06 -0700881 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000882 else
883 good="yes"
884 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800885 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000886 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700887 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700888elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000889 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700890 build_exit="$?"
891 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800892 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700893 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000894 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100895 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000896 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100897 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100898 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000899 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700900 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
901 good="yes"
902 else
Alex Light91de25f2015-10-28 17:00:06 -0700903 cat "$build_output" 1>&${real_stderr} 1>&2
904 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700905 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700906elif [ "$build_only" = "yes" ]; then
907 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000908 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700909 build_exit="$?"
910 if [ "$build_exit" '!=' '0' ]; then
911 cp "$build_output" "$output"
912 echo "build exit status: $build_exit" >>"$output"
913 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
914 if [ "$?" '!=' "0" ]; then
915 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700916 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700917 fi
918 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700919 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700920 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700921 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700922else
David Brazdil4846d132015-01-15 19:07:08 +0000923 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700924 build_exit="$?"
925 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800926 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700927 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000928 run_exit="$?"
929 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700930 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000931 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000932 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100933 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000934 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100935 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100936 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000937 checker_exit="$?"
938 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700939 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000940 good_run="no"
941 else
942 good_run="yes"
943 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000944 else
945 good_run="yes"
946 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700947 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000948 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700949 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700950 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
951 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700952 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700953 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700954 max_name_length=$(getconf NAME_MAX ${tmp_dir})
955 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
956 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700957 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700958 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700959 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700960 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000961 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
962 # output == expected
963 good="yes"
964 echo "${test_dir}: succeeded!" 1>&2
965 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700966 fi
967fi
968
jeffhao5d1ac922011-09-29 17:41:15 -0700969(
Alex Lightbfac14a2014-07-30 09:41:21 -0700970 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700971 echo "${test_dir}: FAILED!"
972 echo ' '
973 echo '#################### info'
974 cat "${td_info}" | sed 's/^/# /g'
975 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700976 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700977 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700978 if [ "$strace" = "yes" ]; then
979 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700980 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700981 echo '####################'
982 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700983 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
984 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
985 # tools used by the given ABI work for both x86 and x86-64.
986 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
987 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700988 echo ' '
989 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700990
Alex Light91de25f2015-10-28 17:00:06 -0700991) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700992
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700993# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +0000994# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700995if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
996 # Bisecting works by skipping different optimization passes which breaks checker assertions.
997 if [ "$run_checker" == "yes" ]; then
998 echo "${test_dir}: not bisecting, checker test." 1>&2
999 else
1000 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001001 echo "${test_dir}: bisecting..." 1>&2
1002 cwd=`pwd`
1003 maybe_device_mode=""
1004 raw_cmd=""
1005 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001006 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001007 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1008 # to exec in order to preserve pid when calling dalvikvm. This is required
1009 # for bisection search to correctly retrieve logs from device.
1010 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001011 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001012 maybe_device_mode="--device"
1013 raw_cmd="$DEX_LOCATION/cmdline.sh"
1014 else
1015 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1016 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001017 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001018 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1019 $maybe_device_mode \
1020 --raw-cmd="$raw_cmd" \
1021 --check-script="$cwd/check" \
1022 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001023 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001024 --timeout=300
1025 fi
1026fi
1027
Alex Lightbfac14a2014-07-30 09:41:21 -07001028# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001029if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001030 cd "$oldwd"
1031 rm -rf "$tmp_dir"
1032 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001033 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001034 fi
1035 if [ "$good" = "yes" ]; then
1036 exit 0
1037 fi
1038fi
1039
1040
1041(
1042 if [ "$always_clean" = "yes" ]; then
1043 echo "${TEST_NAME} files deleted from host "
1044 if [ "$target_mode" == "yes" ]; then
1045 echo "and from target"
1046 fi
1047 else
1048 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1049 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001050 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001051 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001052 fi
1053
Alex Light91de25f2015-10-28 17:00:06 -07001054) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001055
Alex Light6a870fa2016-05-31 16:36:19 -07001056if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1057 exit 0
1058else
1059 exit 1
1060fi